;;; Mode: Lisp; Package: user

;;; Author: John Domingue

;;; The Open University

(in-package "USER")


;(setq *default-pathname-defaults* 
;  (make-pathname :type "cl"))

#+harlequin-pc-lisp
(eval-when (eval load)
  (require "comm"))

#+harlequin-pc-lisp
(defsystem :lispweb-core 
  (:default-pathname (logical-pathname "food:code;http;src;server;lw-solaris;"))
   ;;"~alb/lisp/modules/http/src/server/lw-solaris/")
  :members ("top"
            ;;automatically work out the machine ip address
            "machine-address-details"
            "decl"
            "processes"
           ;;I need a new one from harlequin "getpeername.wfasl"
            "server-lw"
            "services"
            "macros"
            "headers"
            "time"
            "logger"
            "debug"
            "http"
            "key"
            "cookies"
            "methods"
            "sys-pages"   
            "task"
            ;"loader"
	    "utilities"
            )
  :rules
  ((:in-order-to :compile :all (:requires (:load :serial)))))

#+harlequin-unix-lisp
(defsystem :lispweb-core 
  (:default-pathname (logical-pathname "food:code;http;src;server;lw-solaris;"))
   ;;"~alb/lisp/modules/http/src/server/lw-solaris/")
  :members ("top"
            "decl"
            "processes"
            ;;maybe need a new one for 4.1("getpeername.wfasl" :load-only t)
            "server-lw"
            "services"
            "macros"
            "headers"
            "time"
            "logger"
            "debug"
            "http"
            "key"
            "cookies"
            "methods"
            "sys-pages"   
            "task"
            ;"loader"
            "utilities"
            )
  :rules
  ((:in-order-to :compile :all (:requires (:load :serial)))))

#+lispworks
(defsystem :lispweb 
  (:default-pathname (logical-pathname "food:code;http;src;server;lw-solaris;"))
  ;;
  :members ((:lispweb-core :type :system)
            "html"
            "dispatch"
            ;"gd-utils"
            "jslib"
            "pages"
            "lispweb-doc"
            "java"
            "tunnel")
  :rules
  ((:in-order-to :compile :all (:requires (:load :serial)))))

#+allegro
(defsys :lispweb-core 
  "food:code;http;src;server;lw-solaris;"
  "top"
  "decl"
  "processes"
  ;;  "server-acl"
  "server"
  "services"
  "macros"
  "headers"
  "time"
  "logger"
  "debug"
  "http"
  "key"
  "cookies"
  "methods"
  "sys-pages"   
  "task"
  ;;"loader"
  "utilities"
  )

#+allegro
(defsys :lispweb
  "food:code;http;src;server;lw-solaris;"
  :lispweb-core
  "html"
  "dispatch"
					;"gd-utils"
  "jslib"
  "pages"
  "lispweb-doc"
  "java"
  "tunnel")


(eval-when (eval load)
  ;;;use this to load system patches!!
  (formatter "abc")
   )
