;;; Mode: Lisp; Package: java-draw

;;; Author: John Domingue

;;; The Open University

(in-package :http)

(defmethod draw-arrow (x1 y1 x2 y2 (arrow-p (eql :forward)) angle)
  (draw-local-arrowhead x2 y2 angle))

(defmethod draw-arrow (x1 y1 x2 y2 (arrow-p (eql :backward)) angle)
  (draw-local-arrowhead x1 y1 (+ pi angle)))

(defmethod draw-arrow (x1 y1 x2 y2 (arrow-p (eql :double)) angle)
  (draw-local-arrowhead x1 y1 (+ pi angle))
  (draw-local-arrowhead x2 y2 angle))


(defun draw-shaped-arrowhead (x y angle front-angle length)
  (let* ((reversed-angle (+ angle pi))
         (front (/ front-angle 2))
         (side (* (cos front) length))
         (endx (+ x (round (* length (cos reversed-angle)))))
         (endy (+ y (round (* length (sin reversed-angle))))))
    `(,x ,y
	 ,(+ x (round (* side (cos (+ reversed-angle front)))))
	 ,(+ y (round (* side (sin (+ reversed-angle front)))))
	 ,endx ,endy
	 ,(+ x (round (* side (cos (- reversed-angle front)))))
	 ,(+ y (round (* side (sin (- reversed-angle front)))))
	 ,x ,y)))

(defvar *basic-arrowhead-front-angle* (/ pi 4))

(defvar *basic-arrowhead-length* 12)

(defun draw-local-arrowhead (x1 y1 angle)
  (format *jd-stream* "fill_polygon ~{~d%~} "
          (draw-shaped-arrowhead x1 y1 angle
                                 *basic-arrowhead-front-angle*
                                 *basic-arrowhead-length*)))
