;;; Mode: Lisp; Package: jd

;;; Author: John Domingue

;;; The Open University

(in-package :http)

;(setq *jd-applets* '("draw_canvas.class"           
;		     "fill_rect_command.class"
;		     "draw_line_command.class"     
;		     "java_command.class" 
;		     "draw_oval_command.class"
;		     "java_draw.class"
;		     "draw_rect_command.class"
;		     "javadraw.class"
;		     "draw_string_command.class"
;		     "named_colour.class"
;		     "fill_oval_command.class"
;		     "set_colour_command.class"
;		     "fill_polygon_command.class"
;		     "set_font_command.class"))

(eval-when (eval load)
  (register-java-package "/johnd/javadraw/" "/johnd/javadraw/")
  
 ; (mapc #'(lambda (x)
;            (let ((name (format nil "/johnd/javadraw/~a" x))
;                  (path (format nil "/johnd/~a" x)))
;	      (register-java-applet name path)))
;        *jd-applets*)

  )

#|
(eval-when (eval load)
  (http::add-java-package
   '("/johnd" "javadraw")
   (translate-logical-pathname
    "food:code;java;johnd;javadraw;")))
|#

(defvar *jd-stream*)

(defmacro with-canvas ((width height &optional (background-colour :black))
                       &rest commands)
  `(let ((the-width ,width)
         (the-height ,height))
     (http::html-out (applet "johnd.javadraw.javadraw.class"
                             :width the-width
                             :height the-height
                             :param-list (list (list "width" the-width)
                                               (list "height" the-height)
                                               (list "background_colour" (colour-name-to-rgb-string ,background-colour))
                                               (list "commands" (with-output-to-string (*jd-stream*)
	                                                          (declare (special *jd-stream*))
	                                                          ,@commands)))))))
#|
   (format nil "<title>Graph Layout</title>
<!-- Changed by: John Domingue,  3-Jul-1996 -->
<hr>
<applet code=\"~a\" width=~d height=~d>
<param name=width value=\"~d\">
<param name=height value=\"~d\">
<param name=background_colour value=\"~a\">
<param name=commands value=\"~a\">

</applet>
<hr>"
           "johnd.javadraw.javadraw.class"
           ,width ,height
           ,width ,height
           (colour-name-to-rgb-string ,background-colour)
	   (with-output-to-string (*jd-stream*)
	     (declare (special *jd-stream*))
	     ,@commands))))
|#

(editor::setup-indent 'with-canvas 1)

(defun draw-line (x1 y1 x2 y2 &optional arrow-p)
  (format *jd-stream* "draw_line ~d ~d ~d ~d " x1 y1 x2 y2)
  (when arrow-p
    (let* ((dx (- x2 x1))
	   (dy (- y2 y1))
	   (angle (unless (and (zerop dx) (zerop dy))
		    (atan (- y2 y1) (- x2 x1)))))
      (when angle
	(draw-arrow x1 y1 x2 y2 arrow-p angle)))))

;;;spaces not allowed at the moment
(defun draw-string (string x y)
  (format *jd-stream* "draw_string ~a ~d ~d " (substitute #\_ #\space string) x y))

(defun draw-rectangle (x y width height)
  (format *jd-stream* "draw_rectangle ~d ~d ~d ~d " x y width height))

(defun fill-rectangle (x y width height)
  (format *jd-stream* "fill_rectangle ~d ~d ~d ~d " x y width height))

(defun draw-oval (x y width height)
  (format *jd-stream* "draw_oval ~d ~d ~d ~d " x y width height))

(defun fill-oval (x y width height)
  (format *jd-stream* "fill_oval ~d ~d ~d ~d " x y width height))

(defun colour-name-to-rgb (name)
  (xlib::color-rgb (xlib::lookup-color
                    (xlib:screen-default-colormap
                     (xlib::display-default-screen clue::*display*))
                    name)))

;(defun set-colour (colour)
;  (format *jd-stream* "set_colour ~a " colour))


(defun colour-name-to-rgb-string (colour)
  (multiple-value-bind (r g b) (colour-name-to-rgb colour)
    (format nil "~10$%~10$%~10$ " r g b)))

(defun set-colour (colour)
  (format *jd-stream* "set_colour ~a " (colour-name-to-rgb-string colour)))

(defun set-font (name style size)
  (format *jd-stream* "set_font ~a ~a ~d " name style size))

(define-page ("Test Java Draw Page" :func-name java-draw
				    :class :user)
    ;;if :unvisible-source-p gives an error it
    ;;means that the kmi pages haven't been loaded
    ;;:unvisible-source-p t) 
    ()
  (html-out (center (http::header 1 "Testing Java Draw")))
  (html-out (italic (format nil "<p>Testing Java Draw. This system was implemented by ~a.</p>"
			    (http::anchor "http://kmi.open.ac.uk/~john/"
					  "John Domingue"))))
  (with-canvas (100 100 :ivory)
    (draw-coloured-things)))

(defun draw-coloured-things ()
  (set-colour :goldenrod)
  (fill-rectangle 10 10 40 40)
  (set-colour :lightsteelblue)
  (fill-rectangle 50 50 80 70))
