;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology wsmo-use-case)

(DEF-CLASS BUY-TRAIN-TICKET-GOAL
           (GOAL)
           ?GOAL
           ((HAS-INPUT-ROLE
             :VALUE
             HAS-PERSON
             :VALUE
             HAS-DEPARTURE-STATION
             :VALUE
             HAS-DESTINATION-STATION
             :VALUE
             HAS-DATE-AND-TIME)
            (HAS-INPUT-SOAP-BINDING
             :VALUE
             (HAS-PERSON "sexpr")
             :VALUE
             (HAS-DEPARTURE-STATION "sexpr")
             :VALUE
             (HAS-DESTINATION-STATION "sexpr")
             :VALUE
             (HAS-DATE-AND-TIME "sexpr"))
            (HAS-OUTPUT-ROLE :VALUE HAS-BOOKING-ORDER)
            (HAS-OUTPUT-SOAP-BINDING
             :VALUE
             (HAS-BOOKING-ORDER "string"))
            (HAS-PERSON :TYPE PERSON)
            (HAS-DEPARTURE-STATION :TYPE CITY)
            (HAS-DESTINATION-STATION :TYPE CITY)
            (HAS-DATE-AND-TIME :TYPE LIST-DATE-AND-TIME)
            (HAS-BOOKING-ORDER :TYPE STRING)))


(def-class buy-train-ticket-mediator (wg-mediator)
  ((has-source-component :value buy-train-ticket-goal)))

(def-class buy-train-ticket-capability (capability)
  ((used-mediator :value buy-train-ticket-mediator)))

(def-class universal-time-buy-train-ticket-mediator (wg-mediator)
  ((has-source-component :value buy-train-ticket-goal)
   (has-mediation-service :value universal-time-buy-train-ticket-mediation-goal)))

(def-class universal-time-buy-train-ticket-capability (capability)
  ((used-mediator :value universal-time-buy-train-ticket-mediator)))

(DEF-CLASS UNIVERSAL-TIME-BUY-TRAIN-TICKET-MEDIATION-GOAL
           (GOAL)
           ?GOAL
           ((HAS-INPUT-ROLE :VALUE HAS-DATE-AND-TIME)
            (HAS-INPUT-SOAP-BINDING :VALUE (HAS-DATE-AND-TIME "sexpr"))
            (HAS-OUTPUT-ROLE :VALUE HAS-MEDIATED-DATE-AND-TIME)
            (HAS-OUTPUT-SOAP-BINDING
             :VALUE
             (HAS-MEDIATED-DATE-AND-TIME "float"))
            (HAS-DATE-AND-TIME :TYPE LIST-DATE-AND-TIME)
            (HAS-MEDIATED-DATE-AND-TIME :TYPE UNIVERSAL-DATE-AND-TIME)))

(def-class universal-time-buy-train-ticket-mediation-goal-mediator (wg-mediator)
  ((has-source-component :value universal-time-buy-train-ticket-mediation-goal)))

(def-class universal-time-buy-train-ticket-mediation-service (web-service)
  ((has-capability :value universal-time-buy-train-ticket-mediation-service-capability)
   (has-interface :value universal-time-buy-train-ticket-mediation-service-interface)))

(def-class universal-time-buy-train-ticket-mediation-service-capability (capability)
  ((used-mediator :value universal-time-buy-train-ticket-mediation-goal-mediator)))

(def-class english-buy-train-ticket-service (web-service)
  ((has-capability :value english-buy-train-ticket-capability)
   (has-interface :value english-buy-train-ticket-service-interface)))

(def-class english-buy-train-ticket-capability (buy-train-ticket-capability)
  ((has-assumption 
    :value
    (kappa (?goal)
           (and (not (student (wsmo-role-value ?goal 
                             'has-person)))
                (not (business-person (wsmo-role-value ?goal 
                                                  'has-person)))
                (is-in-country 
                 (wsmo-role-value ?goal 
                             'has-departure-station)
                 england)
                (is-in-country 
                 (wsmo-role-value ?goal 
                             'has-destination-station)
                 england))))))


(def-class french-buy-train-ticket-service (web-service)
  ((has-capability :value french-buy-train-ticket-capability)
   (has-interface :value french-buy-train-ticket-service-interface)))

(def-class french-buy-train-ticket-capability (buy-train-ticket-capability)
  ((has-assumption 
    :value
    (kappa (?goal)
           (and (not (student (wsmo-role-value ?goal 
                             'has-person)))
                (not (business-person (wsmo-role-value ?goal 
                                                  'has-person)))
                (is-in-country 
                 (wsmo-role-value ?goal 
                             'has-departure-station)
                 france)
                (is-in-country 
                 (wsmo-role-value ?goal 
                             'has-destination-station)
                 france))))))

(DEF-CLASS GERMAN-BUY-TRAIN-TICKET-SERVICE
           (WEB-SERVICE)
           ?WEB-SERVICE
           ((HAS-INPUT-ROLE :VALUE HAS-DATE-AND-TIME)
            (HAS-DATE-AND-TIME :TYPE UNIVERSAL-DATE-AND-TIME)
            (HAS-CAPABILITY :VALUE GERMAN-BUY-TRAIN-TICKET-CAPABILITY)
            (HAS-INTERFACE
             :VALUE
             GERMAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             GERMAN-BUY-TRAIN-TICKET-SERVICE-NON-FUNC-PROPS)))

(DEF-CLASS GERMAN-BUY-TRAIN-TICKET-CAPABILITY
           (UNIVERSAL-TIME-BUY-TRAIN-TICKET-CAPABILITY)
           ?CAPABILITY
           ((USED-MEDIATOR
             :VALUE
             UNIVERSAL-TIME-BUY-TRAIN-TICKET-MEDIATOR)
            (HAS-ASSUMPTION
             :VALUE
             (KAPPA
              (?GOAL)
              (AND (NOT (STUDENT (WSMO-ROLE-VALUE ?GOAL 'HAS-PERSON)))
                   (NOT (BUSINESS-PERSON
                         (WSMO-ROLE-VALUE ?GOAL 'HAS-PERSON)))
                   (IS-IN-COUNTRY
                    (WSMO-ROLE-VALUE ?GOAL 'HAS-DEPARTURE-STATION)
                    GERMANY)
                   (IS-IN-COUNTRY
                    (WSMO-ROLE-VALUE ?GOAL 'HAS-DESTINATION-STATION)
                    GERMANY))))
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             GERMAN-BUY-TRAIN-TICKET-SERVICE-NON-FUNC-PROPS)))

(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-SERVICE
           (WEB-SERVICE)
           ?WEB-SERVICE
           ((HAS-INPUT-ROLE :VALUE HAS-DATE-AND-TIME)
            (HAS-DATE-AND-TIME :TYPE UNIVERSAL-DATE-AND-TIME)
            (HAS-CAPABILITY
             :VALUE
             AUSTRIAN-BUY-TRAIN-TICKET-CAPABILITY)
            (HAS-INTERFACE
             :VALUE
             AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-NON-FUNC-PROPS)))

(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-CAPABILITY
           (UNIVERSAL-TIME-BUY-TRAIN-TICKET-CAPABILITY)
           ?CAPABILITY
           ((USED-MEDIATOR
             :VALUE
             UNIVERSAL-TIME-BUY-TRAIN-TICKET-MEDIATOR)
            (HAS-ASSUMPTION
             :VALUE
             (KAPPA
              (?GOAL)
              (AND (NOT (STUDENT (WSMO-ROLE-VALUE ?GOAL 'HAS-PERSON)))
                   (NOT (BUSINESS-PERSON
                         (WSMO-ROLE-VALUE ?GOAL 'HAS-PERSON)))
                   (IS-IN-COUNTRY
                    (WSMO-ROLE-VALUE ?GOAL 'HAS-DEPARTURE-STATION)
                    AUSTRIA)
                   (IS-IN-COUNTRY
                    (WSMO-ROLE-VALUE ?GOAL 'HAS-DESTINATION-STATION)
                    AUSTRIA))))
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-NON-FUNC-PROPS)))


(DEF-CLASS EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE
  (WEB-SERVICE)
  ((has-capability :value europe-student-buy-train-ticket-capability)
   (has-interface :value europe-student-buy-train-ticket-service-interface)))

(def-class europe-student-buy-train-ticket-capability (buy-train-ticket-capability)
  ((has-assumption 
    :value
    (kappa (?goal)
           (student 
            (wsmo-role-value ?goal 
                             'has-person))))))


(def-class europe-business-buy-train-ticket-service (web-service)
  ((has-capability :value europe-business-buy-train-ticket-capability)
   (has-interface :value europe-business-buy-train-ticket-service-interface)))

(def-class europe-business-buy-train-ticket-capability (buy-train-ticket-capability)
  ((has-assumption 
    :value
    (kappa (?goal)
           (business-person
            (wsmo-role-value ?goal 
                        'has-person))))))

(def-class get-train-timetable-goal
           (goal)
           ?goal
           ((has-input-role
             :value
             has-departure-station
             :value
             has-destination-station
             :value
             has-date-and-time)
            (has-input-soap-binding
             :value
             (has-departure-station "sexpr")
             :value
             (has-destination-station "sexpr")
             :value
             (has-date-and-time "sexpr"))
            (has-output-role :value has-train-timetable)
            (has-output-soap-binding
             :value
             (has-train-timetable "xml"))
            (has-departure-station :type city)
            (has-destination-station :type city)
            (has-date-and-time :type date-and-time)
            (has-train-timetable :type string)))

(def-class get-train-timetable-capability (capability)
  ((used-mediator :value get-train-timetable-mediator)))

(def-class get-train-timetable-mediator (wg-mediator)
  ((has-source-component :value get-train-timetable-goal)))

(def-class get-train-timetable-service (web-service)
  ((has-capability :value get-train-timetable-capability)
   (has-interface :value get-train-timetable-service-interface)))