;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology wsmo-use-case)

(DEF-CLASS BUY-TRAIN-TICKET-GOAL
           (GOAL)
           ?GOAL
           ((HAS-INPUT-ROLE
             :VALUE
             HAS-PERSON
             :VALUE
             HAS-DEPARTURE-STATION
             :VALUE
             HAS-DESTINATION-STATION
             :VALUE
             HAS-DATE-AND-TIME)
            (HAS-INPUT-SOAP-BINDING
             :VALUE
             (HAS-PERSON "sexpr")
             :VALUE
             (HAS-DEPARTURE-STATION "sexpr")
             :VALUE
             (HAS-DESTINATION-STATION "sexpr")
             :VALUE
             (HAS-DATE-AND-TIME "sexpr"))
            (HAS-OUTPUT-ROLE :VALUE HAS-BOOKING-ORDER)
            (HAS-OUTPUT-SOAP-BINDING
             :VALUE
             (HAS-BOOKING-ORDER "string"))
            (HAS-PERSON :TYPE PERSON)
            (HAS-DEPARTURE-STATION :TYPE CITY)
            (HAS-DESTINATION-STATION :TYPE CITY)
            (HAS-DATE-AND-TIME :TYPE LIST-DATE-AND-TIME)
            (HAS-BOOKING-ORDER :TYPE STRING)
            (HAS-EFFECT
             :VALUE
             (KAPPA
              (?GOAL)
              (AND (HAS-TRAIN-TICKET-BOOKING
                    (WSMO-ROLE-VALUE ?GOAL 'HAS-PERSON)
                    (WSMO-ROLE-VALUE ?GOAL 'HAS-DEPARTURE-STATION)
                    (WSMO-ROLE-VALUE ?GOAL 'HAS-DESTINATION-STATION)
                    (WSMO-ROLE-VALUE ?GOAL 'HAS-DATE-AND-TIME)
                    (WSMO-ROLE-VALUE ?GOAL 'HAS-BOOKING-ORDER))
                   (BOOKING-COST
                    (WSMO-ROLE-VALUE ?GOAL 'HAS-BOOKING-ORDER)
                    ?COST)
                   (HAS-ACCOUNT-DEBIT
                    (WSMO-ROLE-VALUE ?GOAL 'HAS-PERSON)
                    ?COST))))
            (HAS-POST-CONDITION
             :VALUE
             (KAPPA
              (?GOAL)
              (HAS-TRAIN-TICKET-BOOKING
               (WSMO-ROLE-VALUE ?GOAL 'HAS-PERSON)
               (WSMO-ROLE-VALUE ?GOAL 'HAS-DEPARTURE-STATION)
               (WSMO-ROLE-VALUE ?GOAL 'HAS-DESTINATION-STATION)
               (WSMO-ROLE-VALUE ?GOAL 'HAS-DATE-AND-TIME)
               (WSMO-ROLE-VALUE ?GOAL 'HAS-BOOKING-ORDER))))
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             BUY-TRAIN-TICKET-GOAL-NON-FUNCTIONAL-PROPERTIES)))


(def-class buy-train-ticket-mediator (wg-mediator)
  ((has-source-component :value buy-train-ticket-goal)))

(def-class buy-train-ticket-capability (capability)
  ((used-mediator :value buy-train-ticket-mediator)))

(def-class universal-time-buy-train-ticket-mediator (wg-mediator)
  ((has-source-component :value buy-train-ticket-goal)
   (has-mediation-service :value ;;universal-time-buy-train-ticket-mediation-goal lisp goal
                          ;;Goal-Mediate-Time wsmx goal
                          Goal-Mediate-Time)))

(def-class universal-time-buy-train-ticket-capability (capability)
  ((used-mediator :value universal-time-buy-train-ticket-mediator)))

(DEF-CLASS UNIVERSAL-TIME-BUY-TRAIN-TICKET-MEDIATION-GOAL
  (GOAL)
  ?GOAL
  ((HAS-POST-CONDITION
    :VALUE
    (KAPPA
     (?GOAL)
     (universally-transformed-time
      (WSMO-ROLE-VALUE ?GOAL 'HAS-DATE-AND-TIME)
      (WSMO-ROLE-VALUE ?GOAL 'HAS-MEDIATED-DATE-AND-TIME))))
   (HAS-INPUT-ROLE :VALUE HAS-DATE-AND-TIME)
   (HAS-INPUT-SOAP-BINDING :VALUE (HAS-DATE-AND-TIME "sexpr"))
   (HAS-OUTPUT-ROLE :VALUE HAS-MEDIATED-DATE-AND-TIME)
   (HAS-OUTPUT-SOAP-BINDING
    :VALUE
    (HAS-MEDIATED-DATE-AND-TIME "float"))
   (HAS-DATE-AND-TIME :TYPE LIST-DATE-AND-TIME)
   (HAS-MEDIATED-DATE-AND-TIME :TYPE UNIVERSAL-DATE-AND-TIME)))

(def-class universal-time-buy-train-ticket-mediation-goal-mediator (wg-mediator)
  ((has-source-component :value universal-time-buy-train-ticket-mediation-goal)))

(def-class universal-time-buy-train-ticket-mediation-service (web-service)
  ((has-capability :value universal-time-buy-train-ticket-mediation-service-capability)
   (has-interface :value universal-time-buy-train-ticket-mediation-service-interface)))

(def-class universal-time-buy-train-ticket-mediation-service-capability (capability)
  ((used-mediator :value universal-time-buy-train-ticket-mediation-goal-mediator)
   (HAS-PRE-CONDITION :VALUE 
                      (KAPPA
                       (?web-service)
                       (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME)))
   (HAS-POST-CONDITION :VALUE 
                       (KAPPA
                        (?web-service)
                        (universally-transformed-time
                         (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME)
                         (WSMO-ROLE-VALUE ?web-service 'HAS-MEDIATED-DATE-AND-TIME))))))

(DEF-CLASS ENGLISH-BUY-TRAIN-TICKET-SERVICE
           (WEB-SERVICE)
           ?WEB-SERVICE
           ((HAS-CAPABILITY :VALUE ENGLISH-BUY-TRAIN-TICKET-CAPABILITY)
            (HAS-INTERFACE
             :VALUE
             ENGLISH-BUY-TRAIN-TICKET-SERVICE-INTERFACE)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             ENGLISH-BUY-TRAIN-TICKET-SERVICE-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS ENGLISH-BUY-TRAIN-TICKET-CAPABILITY
  (BUY-TRAIN-TICKET-CAPABILITY)
  ?CAPABILITY
  ((USED-MEDIATOR :VALUE BUY-TRAIN-TICKET-MEDIATOR)
   (HAS-PRE-CONDITION :VALUE 
                      (KAPPA
                       (?web-service)
                       (AND (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME))))
   (HAS-POST-CONDITION :VALUE 
                       (KAPPA
                        (?web-service)
                        (and (HAS-TRAIN-TICKET-BOOKING
                              (WSMO-ROLE-VALUE ?web-service HAS-PERSON)
                              (WSMO-ROLE-VALUE ?web-service HAS-DEPARTURE-STATION)
                              (WSMO-ROLE-VALUE ?web-service HAS-DESTINATION-STATION)
                              (WSMO-ROLE-VALUE ?web-service HAS-DATE-AND-TIME)
                              (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER))
                             (NOT (STUDENT (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
                             (NOT (BUSINESS-PERSON
                                   (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
                             (IS-IN-COUNTRY
                              (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                              ENGLAND)
                             (IS-IN-COUNTRY
                              (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                              ENGLAND))))
   (HAS-ASSUMPTION
    :VALUE
    (KAPPA
     (?web-service)
     (AND (NOT (STUDENT (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
          (NOT (BUSINESS-PERSON
                (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
          (IS-IN-COUNTRY
           (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
           ENGLAND)
          (IS-IN-COUNTRY
           (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
           ENGLAND))))
   (HAS-EFFECT :VALUE 
               (KAPPA
                (?web-service)
                (AND (HAS-TRAIN-TICKET-BOOKING
                      (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER))
                     (BOOKING-COST (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER) ?COST)
                     (HAS-ACCOUNT-DEBIT
                      (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                      ?COST)
                     (NOT (STUDENT (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
                     (NOT (BUSINESS-PERSON
                           (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
                     (IS-IN-COUNTRY
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                      ENGLAND)
                     (IS-IN-COUNTRY
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                      ENGLAND))))
   (HAS-NON-FUNCTIONAL-PROPERTIES
    :VALUE
    ENGLISH-BUY-TRAIN-TICKET-CAPABILITY-NON-FUNCTIONAL-PROPERTIES)))


(def-class french-buy-train-ticket-service (web-service)
  ((has-capability :value french-buy-train-ticket-capability)
   (has-interface :value french-buy-train-ticket-service-interface)))

(def-class french-buy-train-ticket-capability (buy-train-ticket-capability)
  ((HAS-PRE-CONDITION :VALUE 
                      (KAPPA
                       (?web-service)
                       (AND (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME))))
   (HAS-POST-CONDITION :VALUE 
                       (KAPPA
                        (?web-service)
                        (and (HAS-TRAIN-TICKET-BOOKING
                              (WSMO-ROLE-VALUE ?web-service HAS-PERSON)
                              (WSMO-ROLE-VALUE ?web-service HAS-DEPARTURE-STATION)
                              (WSMO-ROLE-VALUE ?web-service HAS-DESTINATION-STATION)
                              (WSMO-ROLE-VALUE ?web-service HAS-DATE-AND-TIME)
                              (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER))
                             (not (student (wsmo-role-value ?web-service 
                                                            'has-person)))
                             (not (business-person (wsmo-role-value ?web-service 
                                                                    'has-person)))
                             (is-in-country 
                              (wsmo-role-value ?web-service 
                                               'has-departure-station)
                              france)
                             (is-in-country 
                              (wsmo-role-value ?web-service 
                                               'has-destination-station)
                              france))))
   (HAS-EFFECT :VALUE 
               (KAPPA
                (?web-service)
                (AND (HAS-TRAIN-TICKET-BOOKING
                      (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER))
                     (BOOKING-COST (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER) ?COST)
                     (HAS-ACCOUNT-DEBIT
                      (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                      ?COST)
                     (NOT (STUDENT (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
                     (NOT (BUSINESS-PERSON
                           (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
                     (is-in-country 
                 (wsmo-role-value ?web-service 
                                  'has-departure-station)
                 france)
                (is-in-country 
                 (wsmo-role-value ?web-service 
                                  'has-destination-station)
                 france))))
   (has-assumption 
    :value
    (kappa (?web-service)
           (and (not (student (wsmo-role-value ?web-service 
                                               'has-person)))
                (not (business-person (wsmo-role-value ?web-service 
                                                       'has-person)))
                (is-in-country 
                 (wsmo-role-value ?web-service 
                                  'has-departure-station)
                 france)
                (is-in-country 
                 (wsmo-role-value ?web-service 
                                  'has-destination-station)
                 france))))))

(DEF-CLASS GERMAN-BUY-TRAIN-TICKET-SERVICE
           (WEB-SERVICE)
           ?WEB-SERVICE
           ((HAS-INPUT-ROLE :VALUE HAS-DATE-AND-TIME)
            (HAS-DATE-AND-TIME :TYPE UNIVERSAL-DATE-AND-TIME)
            (HAS-CAPABILITY :VALUE GERMAN-BUY-TRAIN-TICKET-CAPABILITY)
            (HAS-INTERFACE
             :VALUE
             GERMAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             GERMAN-BUY-TRAIN-TICKET-SERVICE-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS GERMAN-BUY-TRAIN-TICKET-CAPABILITY
  (UNIVERSAL-TIME-BUY-TRAIN-TICKET-CAPABILITY)
  ?CAPABILITY
  ((USED-MEDIATOR
    :VALUE
    UNIVERSAL-TIME-BUY-TRAIN-TICKET-MEDIATOR)
   (HAS-PRE-CONDITION :VALUE 
                      (KAPPA
                       (?web-service)
                       (AND (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME))))
   (HAS-POST-CONDITION :VALUE 
                       (KAPPA
                        (?web-service)
                        (and (HAS-TRAIN-TICKET-BOOKING
                              (WSMO-ROLE-VALUE ?web-service HAS-PERSON)
                              (WSMO-ROLE-VALUE ?web-service HAS-DEPARTURE-STATION)
                              (WSMO-ROLE-VALUE ?web-service HAS-DESTINATION-STATION)
                              (WSMO-ROLE-VALUE ?web-service HAS-DATE-AND-TIME)
                              (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER))
                             (not (student (wsmo-role-value ?web-service 
                                                            'has-person)))
                             (not (business-person (wsmo-role-value ?web-service 
                                                                    'has-person)))
                             (IS-IN-COUNTRY
                              (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                              GERMANY)
                             (IS-IN-COUNTRY
                              (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                              GERMANY))))
   (HAS-EFFECT :VALUE 
               (KAPPA
                (?web-service)
                (AND (HAS-TRAIN-TICKET-BOOKING
                      (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER))
                     (BOOKING-COST (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER) ?COST)
                     (HAS-ACCOUNT-DEBIT
                      (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                      ?COST))))
   (HAS-ASSUMPTION
    :VALUE
    (KAPPA
     (?web-service)
     (AND (NOT (STUDENT (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
          (NOT (BUSINESS-PERSON
                (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
          (IS-IN-COUNTRY
           (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
           GERMANY)
          (IS-IN-COUNTRY
           (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
           GERMANY))))
   (HAS-NON-FUNCTIONAL-PROPERTIES
    :VALUE
    GERMAN-BUY-TRAIN-TICKET-CAPABILITY-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-SERVICE
           (WEB-SERVICE)
           ?WEB-SERVICE
           ((HAS-CAPABILITY
             :VALUE
             AUSTRIAN-BUY-TRAIN-TICKET-CAPABILITY)
            (HAS-INTERFACE
             :VALUE
             AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE)
            (USED-MEDIATOR :VALUE AUSTRIA-CITIES-KB-MEDIATOR)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-CAPABILITY
  (UNIVERSAL-TIME-BUY-TRAIN-TICKET-CAPABILITY)
  ?CAPABILITY
  ((USED-MEDIATOR
    :VALUE
    UNIVERSAL-TIME-BUY-TRAIN-TICKET-MEDIATOR)
   (HAS-PRE-CONDITION :VALUE 
                      (KAPPA
                       (?web-service)
                       (AND (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME))))
   (HAS-POST-CONDITION :VALUE 
                       (KAPPA
                        (?web-service)
                        (and (HAS-TRAIN-TICKET-BOOKING
                              (WSMO-ROLE-VALUE ?web-service HAS-PERSON)
                              (WSMO-ROLE-VALUE ?web-service HAS-DEPARTURE-STATION)
                              (WSMO-ROLE-VALUE ?web-service HAS-DESTINATION-STATION)
                              (WSMO-ROLE-VALUE ?web-service HAS-DATE-AND-TIME)
                              (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER))
                             (not (student (wsmo-role-value ?web-service 
                                                            'has-person)))
                             (not (business-person (wsmo-role-value ?web-service 
                                                                    'has-person)))
                             (IS-IN-COUNTRY
                              (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                              AUSTRIA)
                             (IS-IN-COUNTRY
                              (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                              AUSTRIA))))
   (HAS-EFFECT :VALUE 
               (KAPPA
                (?web-service)
                (AND (HAS-TRAIN-TICKET-BOOKING
                      (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER))
                     (BOOKING-COST (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER) ?COST)
                     (HAS-ACCOUNT-DEBIT
                      (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                      ?COST)
                     (NOT (STUDENT (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
                     (NOT (BUSINESS-PERSON
                           (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
                     (IS-IN-COUNTRY
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                      AUSTRIA)
                     (IS-IN-COUNTRY
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                      AUSTRIA))))
   (HAS-ASSUMPTION
    :VALUE
    (KAPPA
     (?web-service)
     (AND (NOT (STUDENT (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
          (NOT (BUSINESS-PERSON
                (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))
          (IS-IN-COUNTRY
           (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
           AUSTRIA)
          (IS-IN-COUNTRY
           (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
           AUSTRIA))))
   (HAS-NON-FUNCTIONAL-PROPERTIES
    :VALUE
    AUSTRIAN-BUY-TRAIN-TICKET-CAPABILITY-NON-FUNCTIONAL-PROPERTIES)))


(DEF-CLASS EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE
           (WEB-SERVICE)
           ?WEB-SERVICE
           ((HAS-CAPABILITY
             :VALUE
             EUROPE-STUDENT-BUY-TRAIN-TICKET-CAPABILITY)
            (HAS-INTERFACE
             :VALUE
             EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-INTERFACE)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS EUROPE-STUDENT-BUY-TRAIN-TICKET-CAPABILITY
           (BUY-TRAIN-TICKET-CAPABILITY)
           ?CAPABILITY
           ((USED-MEDIATOR :VALUE BUY-TRAIN-TICKET-MEDIATOR)
            (HAS-PRE-CONDITION
             :VALUE
             (KAPPA
              (?WEB-SERVICE)
              (AND (WSMO-ROLE-VALUE ?WEB-SERVICE 'HAS-PERSON)
                   (WSMO-ROLE-VALUE
                    ?WEB-SERVICE
                    'HAS-DEPARTURE-STATION)
                   (WSMO-ROLE-VALUE
                    ?WEB-SERVICE
                    'HAS-DESTINATION-STATION)
                   (WSMO-ROLE-VALUE ?WEB-SERVICE 'HAS-DATE-AND-TIME))))
            (HAS-POST-CONDITION
             :VALUE
             (KAPPA
              (?WEB-SERVICE)
              (AND (HAS-TRAIN-TICKET-BOOKING
                    (WSMO-ROLE-VALUE ?WEB-SERVICE HAS-PERSON)
                    (WSMO-ROLE-VALUE
                     ?WEB-SERVICE
                     HAS-DEPARTURE-STATION)
                    (WSMO-ROLE-VALUE
                     ?WEB-SERVICE
                     HAS-DESTINATION-STATION)
                    (WSMO-ROLE-VALUE ?WEB-SERVICE HAS-DATE-AND-TIME)
                    (WSMO-ROLE-VALUE ?WEB-SERVICE 'HAS-BOOKING-ORDER))
                   (STUDENT
                    (WSMO-ROLE-VALUE ?WEB-SERVICE 'HAS-PERSON)))))
            (HAS-ASSUMPTION
             :VALUE
             (KAPPA
              (?WEB-SERVICE)
              (STUDENT (WSMO-ROLE-VALUE ?WEB-SERVICE 'HAS-PERSON))))
            (HAS-EFFECT
             :VALUE
             (KAPPA
              (?WEB-SERVICE)
              (AND (HAS-TRAIN-TICKET-BOOKING
                    (WSMO-ROLE-VALUE ?WEB-SERVICE 'HAS-PERSON)
                    (WSMO-ROLE-VALUE
                     ?WEB-SERVICE
                     'HAS-DEPARTURE-STATION)
                    (WSMO-ROLE-VALUE
                     ?WEB-SERVICE
                     'HAS-DESTINATION-STATION)
                    (WSMO-ROLE-VALUE ?WEB-SERVICE 'HAS-DATE-AND-TIME)
                    (WSMO-ROLE-VALUE ?WEB-SERVICE 'HAS-BOOKING-ORDER))
                   (BOOKING-COST
                    (WSMO-ROLE-VALUE ?WEB-SERVICE 'HAS-BOOKING-ORDER)
                    ?COST)
                   (HAS-ACCOUNT-DEBIT
                    (WSMO-ROLE-VALUE ?WEB-SERVICE 'HAS-PERSON)
                    ?COST)
                   (STUDENT
                    (WSMO-ROLE-VALUE ?WEB-SERVICE 'HAS-PERSON)))))
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             EUROPE-STUDENT-BUY-TRAIN-TICKET-CAPABILITY-NON-FUNCTIONAL-PROPERTIES)))


(def-class europe-business-buy-train-ticket-service (web-service)
  ((has-capability :value europe-business-buy-train-ticket-capability)
   (has-interface :value europe-business-buy-train-ticket-service-interface)))

(def-class europe-business-buy-train-ticket-capability (buy-train-ticket-capability)
  ((HAS-PRE-CONDITION :VALUE 
                      (KAPPA
                       (?web-service)
                       (AND (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME))))
   (HAS-POST-CONDITION :VALUE 
                       (KAPPA
                        (?web-service)
                        (and (HAS-TRAIN-TICKET-BOOKING
                              (WSMO-ROLE-VALUE ?web-service HAS-PERSON)
                              (WSMO-ROLE-VALUE ?web-service HAS-DEPARTURE-STATION)
                              (WSMO-ROLE-VALUE ?web-service HAS-DESTINATION-STATION)
                              (WSMO-ROLE-VALUE ?web-service HAS-DATE-AND-TIME)
                              (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER))
                             (business-person (wsmo-role-value ?web-service 
                                                               'has-person)))))
   (HAS-EFFECT :VALUE 
               (KAPPA
                (?web-service)
                (AND (HAS-TRAIN-TICKET-BOOKING
                      (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME)
                      (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER))
                     (BOOKING-COST (WSMO-ROLE-VALUE ?web-service 'HAS-BOOKING-ORDER) ?COST)
                     (HAS-ACCOUNT-DEBIT
                      (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)
                      ?COST)
                     (BUSINESS-PERSON
                      (WSMO-ROLE-VALUE ?web-service 'HAS-PERSON)))))
   (has-assumption 
    :value
    (kappa (?web-service)
           (business-person
            (wsmo-role-value ?web-service 
                             'has-person))))))

(def-class get-train-timetable-goal
           (goal)
           ?web-service
           ((HAS-POST-CONDITION
             :VALUE
             (KAPPA
              (?GOAL)
              (HAS-TRAIN-time-table
               (WSMO-ROLE-VALUE ?GOAL 'HAS-DEPARTURE-STATION)
               (WSMO-ROLE-VALUE ?GOAL 'HAS-DESTINATION-STATION)
               (WSMO-ROLE-VALUE ?GOAL 'HAS-DATE-AND-TIME)
               (WSMO-ROLE-VALUE ?GOAL 'has-train-timetable))))
            (has-input-role
             :value
             has-departure-station
             :value
             has-destination-station
             :value
             has-date-and-time)
            (has-input-soap-binding
             :value
             (has-departure-station "sexpr")
             :value
             (has-destination-station "sexpr")
             :value
             (has-date-and-time "sexpr"))
            (has-output-role :value has-train-timetable)
            (has-output-soap-binding
             :value
             (has-train-timetable "xml"))
            (has-departure-station :type city)
            (has-destination-station :type city)
            (has-date-and-time :type date-and-time)
            (has-train-timetable :type string)))

(def-class get-train-timetable-capability (capability)
  ((used-mediator :value get-train-timetable-mediator)
   (HAS-PRE-CONDITION :VALUE 
                      (KAPPA
                       (?web-service)
                       (AND (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
                            (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME))))
   (HAS-POST-CONDITION
             :VALUE
             (KAPPA
              (?web-service)
              (HAS-TRAIN-time-table
               (WSMO-ROLE-VALUE ?web-service 'HAS-DEPARTURE-STATION)
               (WSMO-ROLE-VALUE ?web-service 'HAS-DESTINATION-STATION)
               (WSMO-ROLE-VALUE ?web-service 'HAS-DATE-AND-TIME)
               (WSMO-ROLE-VALUE ?web-service 'has-train-timetable))))))

(def-class get-train-timetable-mediator (wg-mediator)
  ((has-source-component :value get-train-timetable-goal)))

(def-class get-train-timetable-service (web-service)
  ((has-capability :value get-train-timetable-capability)
   (has-interface :value get-train-timetable-service-interface)))


