;;; Mode: Lisp; Package: ocml

;;; The Open University

(in-package "OCML")


(in-ontology GenHospitalBedService)


(def-class gen_hospital_bed_service (primitive-method) ?psm
  ((has-input-role :value has_medical_service
                   :value has_hospital_name)
   
   (has-output-role :value has_first_available_date)
   (has_hospital_name :type hospital :cardinality 1)
   (has_medical_service :type medical-service :cardinality 1)
   (has_first_available_date :type calendar-date :cardinality 1)
  (has-precondition 
    :value (kappa (?psm)
                (and (hospital (role-value ?psm has_hospital_name))
                     (medical-service (role-value ?psm has_medical_service)))))
  ))


(def-class hip_hip_hospital_bed_service (gen_hospital_bed_service) ?psm
  ()
  :own-slots ((tackles-task-type hospital_bed_service)
              (applicability-condition 
               (kappa (?task)
                      (= (role-value ?task 
                                     'has_hospital_name)
                         hip-hip-hospital)))))

(def-class the_hippy_hospital_bed_service (gen_hospital_bed_service) ?psm
  ()
  :own-slots ((tackles-task-type hospital_bed_service)
              (applicability-condition 
               (kappa (?task)
                      (= (role-value ?task 
                                     'has_hospital_name)
                         the-hippy-hospital)))))

(def-class  not_the_hippy_hospital_bed_service (gen_hospital_bed_service) ?psm
  ()
  :own-slots ((tackles-task-type hospital_bed_service)
              (applicability-condition 
               (kappa (?task)
                      (= (role-value ?task 
                                     'has_hospital_name)
                        not-the-hippy-hospital)))))

(def-class another_hippy_hospital_bed_service (gen_hospital_bed_service) ?psm
  ()
  :own-slots ((tackles-task-type hospital_bed_service)
              (applicability-condition 
               (kappa (?task)
                      (= (role-value ?task 
                                     'has_hospital_name)
                         another-hippy-hospital)))))


