;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology aktive-portal-services)

;;still to do relevant-publications



(def-rule research-area-related-area-rule
    ((related-research-area ?research-area ?related-research-area)
     if
     (sub-area-of ?research-area ?related-research-area))
    ((related-research-area ?research-area ?related-research-area)
     if
     (sub-area-of ?related-research-area ?research-area)))

(def-relation related-research-area (?research-area ?related-research-area)
  :argument-types (research-area research-area ))


(def-rule research-area-related-person-rule
    ((related-person ?research-area ?person-name)
     if
     (has-research-interest ?person ?research-area)
     (full-name ?person ?person-name)))

(def-relation related-person (?research-area ?person)
  :argument-types (research-area person))

(def-rule research-area-related-project-rule
    ((related-project ?research-area ?project)
     if
     (addresses-generic-area-of-interest ?project ?research-area)
     (project ?project)))

(def-relation related-project (?research-area ?project)
  :argument-types (research-area project))

(def-rule research-area-related-technology-rule
    ((related-technology ?research-area ?technology)
     if
     (addresses-generic-area-of-interest ?technology ?research-area)
     (technology ?technology)))

(def-relation related-technology (?research-area ?technology)
  :argument-types (research-area technology))

(def-rule research-area-related-story-rule
    ((related-story ?research-area ?headline)
     if
     (related-person ?research-area ?person)
     (related-stories person ?person ?headline)))

(def-relation related-story (?research-area ?headline)
  :argument-types (research-area string))

(def-rule research-area-number-of-researchers-rule
    ((number-of-researchers ?research-area ?n)
     if
     (= ?r (setofall ?x (and (has-research-interest ?x ?research-area) (person ?x))))
     (= ?n (length ?r))))

(def-relation number-of-researchers (?research-area ?n)
  :argument-types (research-area integer))

(def-rule research-area-number-of-projects-rule
    ((number-of-projects ?research-area ?n)
     if
     (= ?r (setofall ?x (and (addresses-generic-area-of-interest ?x ?research-area)
                             (project ?x))))
     (= ?n (length ?r))))

(def-relation number-of-projects (?research-area ?n)
  :argument-types (research-area integer))

(def-rule research-area-number-of-stories-rule
    ((number-of-stories ?research-area ?n)
     if
     (= ?r (setofall ?x (related-story research-area ?research-area ?x)))
     (= ?n (length ?r))))

(def-relation number-of-stories (?research-area ?n)
  :argument-types (research-area integer))

(def-rule research-area-log-popularity-rule
    ((log-popularity ?research-area ?n)
     if
     (has-popularity ?research-area ?x)
     (= ?y (log ?x))
     (= ?n (round ?y))))

(def-relation log-popularity (?research-area ?n)
  :argument-types (research-area integer))

(def-rule research-area-kpopularity-rule
    ((kpopularity ?research-area ?n)
     if
     (has-popularity ?research-area ?x)
     (= ?y (/ ?x 10000))
     (= ?n (round ?y))))
     


