;;; Mode: Lisp; Package: ocml

;;; The Open University

(in-package "OCML")


(in-ontology GenAmbulanceService)

(def-class  gen_ambulance_service  (primitive-method) ?psm
  ((has-input-role :value has_start_location
                   :value has_destination_location
                   :value has_currency)
   
   (has-output-role :value has_cost)
   (has_start_location :type location :cardinality 1)
   (has_currency :type currency :cardinality 1)
   (has_destination_location :type location :cardinality 1)
   (has_cost :type positive-number :cardinality 1)
   (has-postcondition
    :value (kappa (?psm ?sol)
                  ( positive-number ?sol)))))


(def-class air_ambulance_service ( gen_ambulance_service ) ?psm
  ()
  :own-slots ((tackles-task-type ambulance_service)
              ))

(def-class rail_ambulance_service ( gen_ambulance_service ) ?psm
  ()
  :own-slots ((tackles-task-type ambulance_service)
              ))




