;;; Mode: Lisp; Package: ocml

;;; The Open University

(in-package "OCML")


(in-ontology medicalservicelocator)


(def-class medical_service_locator (primitive-method) ?psm
  ((has-input-role :value has_medical_service
                   )
   (has-output-role :value has_hospitals)
   (has_medical_service :type medical-service :cardinality 1)
   (has_hospitals :type list :cardinality 1)
  (has-precondition 
    :value (kappa (?psm)
                 (medical-service (role-value ?psm has_medical_service))))
  (has-postcondition 
    :value (kappa (?psm ?sol)
                  (and (list (role-value ?psm has_hospitals))
                       (every (role-value ?psm has_hospitals) hospital)))))
  :own-slots ((tackles-task-type medical_service_location)))

;;we have this so we can republish above as a (soap endpoint) url
(def-class medical_service_locator_as_url (primitive-method) ?psm
  ((has-input-role :value has_medical_service
                   )
   (has-output-role :value has_hospitals)
   (has_medical_service :type medical-service :cardinality 1)
   (has_hospitals :type list :cardinality 1)
  (has-precondition 
    :value (kappa (?psm)
                 (medical-service (role-value ?psm has_medical_service))))
  (has-postcondition 
    :value (kappa (?psm ?sol)
                  (and (list (role-value ?psm has_hospitals))
                       (every (role-value ?psm has_hospitals) hospital)))))
  :own-slots ((tackles-task-type medical_service_location_as_url)))


