;;; -*- Mode: LISP; Syntax: Common-lisp; Base: 10; Package: COMMON-LISP-USER;   -*-

(in-package "COMMON-LISP-USER")


;;;This file sets the logical pathnames translations and needs to 
;;;be customised for each site. 

 

;;;You have to modify this form to set the mapping 
;;;between logical and physical pathnames in your site
#+:mcl
(eval-when (eval compile load)
  (setf (logical-pathname-translations "UTIL") 
      `(("VERSION;V7.1;**;*" "Enrico's Stuff:Enrico:code:util:versions:v7.1:**:*")
        ("EXPERIMENTAL;**;*" "Enrico's Stuff:Enrico:code:util:versions:v7.1:**:*")
        ("RELEASED;**;*" "Enrico's Stuff:Enrico:code:util:versions:v7.1:**:*")
        ))
  (setf (logical-pathname-translations "OCML") 
      `(("VERSION;V7.1;**;*" "Enrico's Stuff:Enrico:code:ocml:versions:v7.1:**:*")
        ("VERSION;V7.0;**;*" "Enrico's Stuff:Enrico:code:ocml:versions:v7.0:**:*")
        ("EXPERIMENTAL;**;*" "Enrico's Stuff:Enrico:code:ocml:versions:v7.1:**:*")
        ("RELEASED;**;*" "Enrico's Stuff:Enrico:code:ocml:versions:v7.1:**:*")
        ("LIBRARY;**;*" "Enrico's Stuff:Enrico:code:ocml:library:v5.0:**:*")
        )))

#+:mcl
(eval-when (eval compile load)
  (setf (logical-pathname-translations "FREAKY") 
      `(("EXPERIMENTAL;**;*" "Enrico's Stuff:Enrico:code:freaky:**:*")
        ("RELEASED;**;*" "Enrico's Stuff:Enrico:code:freaky:**:*")
        ("LIBRARY;**;*" "Enrico's Stuff:Enrico:code:freaky:library:**:*")
        ("RDF-FILES;**;*" "Enrico's Stuff:Enrico:code:freaky:rdf-files:**:*"))))


#+:mcl
(eval-when (eval compile load)
  (setf (logical-pathname-translations "WILBUR") 
      `(("core;*.*" "Enrico's Stuff:Enrico:code:wilbur:core:source:*.*")
        ("load;*.*" "Enrico's Stuff:Enrico:code:wilbur:core:*.*")
        ("schemata;*.*" "Enrico's Stuff:Enrico:code:wilbur:core:schemata:*.*")
        )))


#+(and :LISPWORKS
       (not :HARLEQUIN-PC-LISP))
(eval-when (eval compile load)
  (setf (logical-pathname-translations "UTIL")
      `(("VERSION;V7.1;**;*" 
         ,(translate-logical-pathname "food:lisp;util;**;*"))
        ("EXPERIMENTAL;**;*" 
         ,(translate-logical-pathname "food:lisp;util;**;*")) 
        ("RELEASED;**;*" 
         ,(translate-logical-pathname "food:lisp;util;**;*"))
	))
  (setf (logical-pathname-translations "OCML")
        
      `(("VERSION;V7.1;**;*" ,(translate-logical-pathname "food:lisp;ocml;**;*"))
        ("VERSION;V7.0;**;*" ,(translate-logical-pathname "food:lisp;ocml;**;*"))
        ("EXPERIMENTAL;**;*" ,(translate-logical-pathname "food:lisp;ocml;**;*"))
        ("RELEASED;**;*" ,(translate-logical-pathname "food:lisp;ocml;**;*"))
        ("LIBRARY;**;*" ,(translate-logical-pathname "food:lisp;ocml;library;**;*"))
        )
      ))



#+:HARLEQUIN-PC-LISP
(eval-when (eval compile load)
  (setf (logical-pathname-translations "UTIL")
      '(("EXPERIMENTAL;**;*" "C:\\users\\jbd2\\code\\util\\versions\\v7.1\\**\\*")
        ("VERSION;V7.1;**;*" "C:\\users\\jbd2\\code\\util\\versions\\v7.1\\**\\*")
        ("RELEASED;**;*" "C:\\users\\jbd2\\code\\util\\versions\\v7.1\\**\\*")
        ))
  (setf (logical-pathname-translations "OCML")
        '(("VERSION;V7.1;**;*" "C:\\users\\jbd2\\code\\ocml\\versions\\v7.1\\**\\*")
          ("VERSION;V7.0;**;*" "C:\\users\\jbd2\\code\\ocml\\versions\\v7.0\\**\\*")
          ("EXPERIMENTAL;**;*" "C:\\users\\jbd2\\code\\ocml\\versions\\v7.1\\**\\*")
          ("RELEASED;**;*" "C:\\users\\jbd2\\code\\ocml\\versions\\v7.1\\**\\*")
          ("LIBRARY;**;*" "C:\\users\\jbd2\\code\\ocml\\library\\v5.0\\**\\*")
          )))
        
      


(defvar *default-util-pathname* "UTIL:EXPERIMENTAL;")
(defvar *default-util-load-file* "UTIL:EXPERIMENTAL;SYSDCL")



(defvar *lisp-suffix*)

(eval-when (eval load)
  #+:LISPWORKS (setf *lisp-suffix* "lisp")
  #+:allegro (setf *lisp-suffix* "lisp")
  #+:mcl(setf *lisp-suffix* "lisp")
  #+:windows(setf *lisp-suffix* "lisp"))

(defvar *binary-suffix*)
  

(eval-when (eval load)
  #+:HARLEQUIN-PC-LISP (setf *binary-suffix* "fsl")
  #+allegro(setf *binary-suffix* "fasl")
  #+:mcl(setf *binary-suffix* "pfsl"))

 
(defun compile-file-if-necessary (file)
  (Let ((flag (or (not (probe-file (concatenate 'string file "." *binary-suffix*)))
                  (and (< (file-write-date (concatenate 'string file "." *binary-suffix*))
                          (file-write-date (concatenate 'string file "." *lisp-suffix*)))))))
    (when flag
      (compile-file  file :verbose t))))

(defun simple-load-system (files &optional compile? force?)
  (Let ((fun (if force?
               #'(lambda (x)
                   (delete-file  (concatenate 'string x "." *binary-suffix*)
                                 :if-does-not-exist nil)
                   (compile-file x :verbose t)
                   (load x :verbose t))
               (if compile?
                 #'(lambda (x)
                     (compile-file-if-necessary x)
                     (load x :verbose t))
                 #'(lambda (x) 
                     (load x :verbose t))))))
       
    (map nil fun 
        files)))
